### Method

# EDataServer WebDAVSession options_sync

since: 3.26

#### Declaration [src]

    gboolean
    e_webdav_session_options_sync (
      EWebDAVSession* webdav,
      const gchar* uri,
      GHashTable** out_capabilities,
      GHashTable** out_allows,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Issues OPTIONS request on the provided `uri`, or, in case it’s `NULL`, on the URI defined in associated `ESource`.

The `out_capabilities` contains a set of returned capabilities. Some known are defined as E_WEBDAV_CAPABILITY_CLASS_1, and so on. The ‘value’ of the `GHashTable` doesn’t have any particular meaning and the strings are compared case insensitively. Free the hash table with g_hash_table_destroy(), when no longer needed. The returned value can be `NULL` on success, it’s when the server doesn’t provide the information.

The `out_allows` contains a set of allowed methods returned by the server. Some known are defined as `SOUP_METHOD_OPTIONS`, and so on. The ‘value’ of the `GHashTable` doesn’t have any particular meaning and the strings are compared case insensitively. Free the hash table with g_hash_table_destroy(), when no longer needed. The returned value can be `NULL` on success, it’s when the server doesn’t provide the information.

Available since: 3.26

#### Parameters

`uri`

  Type: `const gchar*`

  URI to issue the request for, or `NULL` to read from `ESource`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`out_capabilities`

  Type: `GHashTable`

  Return location for DAV capabilities.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`out_allows`

  Type: `GHashTable`

  Return location for allowed operations.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

Whether succeeded.